diff -ur sendmail-8.14.5/cf/m4/proto.m4 sendmail-8.14.5-feser/cf/m4/proto.m4
--- sendmail-8.14.5/cf/m4/proto.m4	2010-11-23 23:29:47.000000000 +0300
+++ sendmail-8.14.5-feser/cf/m4/proto.m4	2011-12-05 11:51:39.752902873 +0400
@@ -580,6 +580,18 @@
 # once the threshold number of recipients have been rejected
 _OPTION(BadRcptThrottle, `confBAD_RCPT_THROTTLE', `0')
 
+ifdef(`_FFR_BADRCPT_SHUTDOWN', `dnl
+# Number of bad recipients before connection is evaluated for
+# shutdown with 421 code. Zero disables. Numbers less than 5 not
+# recommended.
+_OPTION(BadRcptShutdown, `confBAD_RCPT_SHUTDOWN', `0')
+# Percentage of bad recipients of total before shutdown is 
+# allowed. 81 is a good number, only dropping connection if 
+# 2 out of 10 rcpts or less are good.
+# If 100, the connection will never be shut down if there are any good
+# recipients.  If 0 the connection will be shut down as soon as
+# BadRcptShutdown bad rcpts are reached.
+_OPTION(BadRcptShutdownGood, `confBAD_RCPT_SHUTDOWN_GOOD', `0')')
 
 # shall we get local names from our installed interfaces?
 _OPTION(DontProbeInterfaces, `confDONT_PROBE_INTERFACES', `False')
